/* This file is part of mailfrom filter.
   Copyright (C) 2006 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
   MA 02110-1301 USA */

typedef void *STKVAL;

struct eval_environ;

void runtime_warning(eval_environ_t env, const char *fmt, ...);
void runtime_error(eval_environ_t env, const char *fmt, ...);
STKVAL get_arg(eval_environ_t env, unsigned n);
void push(eval_environ_t env, STKVAL val);
STKVAL pop(eval_environ_t env);
STKVAL heap_reserve(eval_environ_t env, size_t size);
STKVAL heap_tempspace(eval_environ_t env, size_t size);
STKVAL heap_max_tempspace(eval_environ_t env, size_t *size);
STKVAL heap_fix_tempspace(eval_environ_t env, size_t size);
void pushs(eval_environ_t env, char *s);
void advance_pc(eval_environ_t env, unsigned cnt);
void adjust_stack(eval_environ_t env, unsigned cnt);
void prog_trace(eval_environ_t env, const char *fmt, ...);
STKVAL *env_var_ref(eval_environ_t env, size_t off);
void env_var_inc(eval_environ_t env, size_t off);
char *env_dict_getsym(eval_environ_t env, char *string);
char *env_dict_install(eval_environ_t env, char *key, char *value);
const struct locus *env_get_locus(eval_environ_t env);
void *env_get_builtin_priv(eval_environ_t env, int id);
int builtin_priv_register(void *(*init)(void), void (*destroy)(void*));

int variable_declared_p(const char *name);
void declare_variable(char *name, size_t off, STKVAL value);

void post_parse(void);

extern unsigned error_count; 
extern unsigned long prog_trace_option;
